package com.its.op.service.its.scrs;

import com.its.op.dao.repository.its.scrs.TbScWeekHmsCntlRepository;
import com.its.op.dto.its.scrs.TbScWeekHmsCntlDto;
import com.its.op.entity.its.scrs.TbScWeekHmsCntl;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;
import java.util.Optional;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbScWeekHmsCntlService {

    private final TbScWeekHmsCntlRepository repo;

    // 데이터 1건 조회, 없으면 exception
    private TbScWeekHmsCntl requireOne(Integer ixrGrop) throws NoSuchElementException {
        Optional<TbScWeekHmsCntl> info = this.repo.findById(ixrGrop);
        if (info.isPresent()) {
            return info.get();
        }
        else {
            throw new NoSuchElementException("데이터가 존재하지 않습니다: " + ixrGrop);
        }
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbScWeekHmsCntlDto> findAll() {
        List<TbScWeekHmsCntlDto> result = new ArrayList<>();
        List<TbScWeekHmsCntl> data = this.repo.findAll();
        for (TbScWeekHmsCntl entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbScWeekHmsCntlDto> findAllList() {
        List<TbScWeekHmsCntlDto> result = new ArrayList<>();
        List<TbScWeekHmsCntl> data = this.repo.findAllList();
        for (TbScWeekHmsCntl entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 데이터 1건 조회(기존 데이터가 반드시 존재해야 함)
    @Transactional(readOnly = true)
    public TbScWeekHmsCntlDto findById(Integer ixrGrop) {
        TbScWeekHmsCntl entity = requireOne(ixrGrop);
        return entity.toDto();
    }

    // 데이터 변경
    @Transactional
    public TbScWeekHmsCntlDto updateById(Integer ixrGrop, TbScWeekHmsCntlDto.TbScWeekHmsCntlUpdReq req) {
        TbScWeekHmsCntl entity = requireOne(ixrGrop);
        entity.updateInfo(req);
        this.repo.save(entity);
        return entity.toDto();
    }

    // 데이터 변경 또는 생성-목록(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public List<TbScWeekHmsCntlDto> mergeInfoList(List<TbScWeekHmsCntlDto.TbScWeekHmsCntlUpdReq> reqList) {
        List<TbScWeekHmsCntlDto> result = new ArrayList<>();
        for (TbScWeekHmsCntlDto.TbScWeekHmsCntlUpdReq req : reqList) {
            TbScWeekHmsCntl obj = req.toEntity();
            this.repo.save(obj);
            result.add(obj.toDto());
        }
        return result;
    }

    // 데이터 변경 또는 생성-개별(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public TbScWeekHmsCntlDto mergeInfo(TbScWeekHmsCntlDto.TbScWeekHmsCntlUpdReq req) {
        TbScWeekHmsCntl obj = req.toEntity();
        this.repo.save(obj);
        return obj.toDto();
    }

    // 정보 삭제-개별, 데이터 존재하지 않으면 Exception
    @Transactional
    public TbScWeekHmsCntlDto deleteById(Integer ixrGrop) {
        TbScWeekHmsCntl entity = requireOne(ixrGrop);
        this.repo.deleteById(ixrGrop);
        return entity.toDto();
    }

    // 정보 삭제-목록, 존재하는 데이터 만 삭제
    @Transactional
    public List<TbScWeekHmsCntlDto> deleteByIds(List<Integer> ids) {
        List<TbScWeekHmsCntlDto> result = new ArrayList<>();
        for (Integer id : ids) {
            Optional<TbScWeekHmsCntl> obj = this.repo.findById(id);
            if (obj.isPresent()) {
                this.repo.deleteById(id);
                result.add(obj.get().toDto());
            }
        }
        return result;
    }

}
